#ifndef _KGR_PATCH_BSC1057950_H
#define _KGR_PATCH_BSC1057950_H

#if IS_ENABLED(CONFIG_BT)

int kgr_patch_bsc1057950_init(void);
void kgr_patch_bsc1057950_cleanup(void);


struct l2cap_conn;
struct l2cap_chan;
struct l2cap_cmd_hdr;
struct hci_conn;
struct sk_buff;

void kgr_l2cap_conn_start(struct l2cap_conn *conn);
void kgr__l2cap_connect_rsp_defer(struct l2cap_chan *chan);
struct l2cap_chan *kgr_l2cap_connect(struct l2cap_conn *conn,
				     struct l2cap_cmd_hdr *cmd,
				     u8 *data, u8 rsp_code, u8 amp_id);
int kgr_l2cap_connect_create_rsp(struct l2cap_conn *conn,
				struct l2cap_cmd_hdr *cmd, u16 cmd_len,
				u8 *data);
void kgr_l2cap_do_create(struct l2cap_chan *chan, int result,
			 u8 local_amp_id, u8 remote_amp_id);
void kgr_l2cap_security_cfm(struct hci_conn *hcon, u8 status, u8 encrypt);
void kgr_l2cap_recv_frame(struct l2cap_conn *conn, struct sk_buff *skb);

#define KGR_PATCH_BSC1057950_FUNCS					\
	KGR_PATCH_OBJ(l2cap_conn_start, kgr_l2cap_conn_start,		\
			"bluetooth"),					\
	KGR_PATCH_OBJ(__l2cap_connect_rsp_defer,			\
			kgr__l2cap_connect_rsp_defer, "bluetooth"),	\
	KGR_PATCH_OBJ(l2cap_connect, kgr_l2cap_connect, "bluetooth"),	\
	KGR_PATCH_OBJ(l2cap_connect_create_rsp,			\
			kgr_l2cap_connect_create_rsp, "bluetooth"),	\
	KGR_PATCH_OBJ(l2cap_do_create, kgr_l2cap_do_create,		\
			"bluetooth"),					\
	KGR_PATCH_OBJ(l2cap_security_cfm, kgr_l2cap_security_cfm,	\
			"bluetooth"),					\
	KGR_PATCH_OBJ(l2cap_recv_frame, kgr_l2cap_recv_frame,		\
			"bluetooth"),

#else

static int kgr_patch_bsc1057950_init(void) { return 0; }
static void kgr_patch_bsc1057950_cleanup(void) {}
#define KGR_PATCH_BSC1057950_FUNCS

#endif
#endif
